# Betwiin v1.0, Copyright 2009 Haxx Enterprises (bushing@gmail.com)
# Licensed to you under the terms of the GNU GPL v2.0; see http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt

import os, sys, struct, hashlib, hmac, numpy
from struct import unpack, pack
from Crypto.Cipher import AES
from nand import *

cluster_contents = {}

def recur_copyclusters(entry):
	for c in entry.children():
		recur_copyclusters(c)
	if entry.is_file():
		print "Cluster chain for %s:" % (entry.path+entry.name)
		clusters = entry.get_cluster_chain()
#		print clusters
		for x in range(0, len(clusters)):
			calculated = entry.calc_hmac(input_nand, x)
			stored = input_nand.get_cluster_hmac(clusters[x])
			if calculated != stored:
				print "Calc HMAC: " + hexdump(calculated)
				print "Stored HMAC: " + hexdump(input_nand.get_cluster_hmac(clusters[x]))
				print "You fail it."
#				exit(1)
#			else:
#				print "HMAC okay in input file for cluster %d" % (clusters[x])
			decrypted_cluster = input_nand.decrypt_cluster(clusters[x])
			output_nand.encrypt_cluster(clusters[x], input_nand.decrypt_cluster(clusters[x]))
			output_nand.set_cluster_hmac(clusters[x], entry.calc_hmac(output_nand, x))

input_hmac = read_file("input/nand-hmac")
input_key = read_file("input/nand-key")
output_hmac = read_file("output/nand-hmac")
output_key = read_file("output/nand-key")

print "Creating empty output image:"
output_image = open("output/flash.bin", "wb")

for cluster in range(0,0x8000):
	output_image.write("\xff" * 0x4200)
output_image.close()

print "Copying boot1 / boot2:"

input_nand = NANDFormatSpare("input/flash.bin")
input_nand.set_keys(input_key, input_hmac)
output_nand = NANDFormatSpare("output/flash.bin")
output_nand.set_keys(output_key, output_hmac)

for cluster in range(0,0x40):
	output_nand.set_cluster(cluster, input_nand.get_cluster(cluster))

superblock_cluster = find_newest_superblock(input_nand)

for clusterno in range(superblock_cluster, superblock_cluster + 0x10):
	output_nand.set_cluster(clusterno, input_nand.get_cluster(clusterno))
	output_nand.update_cluster_ecc(clusterno)

latest_superblock = SFFS(read_superblock(input_nand, superblock_cluster))

calc_hmac = latest_superblock.calc_hmac(superblock_cluster, output_nand.hmac_key)
output_nand.set_cluster_hmac(superblock_cluster + 0xf, calc_hmac)

recur_copyclusters(SFFS_entry(latest_superblock.fst, latest_superblock.fat, 0, ""))
